"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryFilterGroup = void 0;
var _common_1 = require("../../../index");
var QueryFilterGroup = (function () {
    function QueryFilterGroup(filters, filterOperator, groupOperator) {
        if (filterOperator === void 0) { filterOperator = _common_1.FilterOperator.and; }
        if (groupOperator === void 0) { groupOperator = _common_1.FilterOperator.and; }
        this.filters = filters;
        this.filterOperator = filterOperator;
        this.groupOperator = groupOperator;
        Object.freeze(this);
    }
    QueryFilterGroup.fromApiTableFilter = function (filter) {
        return new QueryFilterGroup([filter]);
    };
    QueryFilterGroup.fromColumnValues = function (values, columnName, filterOperator) {
        if (filterOperator === void 0) { filterOperator = _common_1.FilterOperator.or; }
        return new QueryFilterGroup(values.map(function (value) { return new _common_1.QueryFilter(value, 'EQUAL', columnName); }), filterOperator);
    };
    QueryFilterGroup.fromTimeFrame = function (columnName, startDate, endDate) {
        var filters = [];
        if (startDate) {
            filters.push(new _common_1.QueryFilter(startDate.toISOString(), 'GREATER_THAN', columnName));
        }
        if (endDate) {
            filters.push(new _common_1.QueryFilter(endDate.toISOString(), 'LESS_THAN', columnName));
        }
        return new QueryFilterGroup(filters);
    };
    return QueryFilterGroup;
}());
exports.QueryFilterGroup = QueryFilterGroup;
//# sourceMappingURL=query-filter-group.js.map