"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrashApiClient = void 0;
var argument_contracts_1 = __importDefault(require("argument-contracts"));
var crash_details_1 = require("../crash-details/crash-details");
var CrashApiClient = (function () {
    function CrashApiClient(_client) {
        this._client = _client;
    }
    CrashApiClient.prototype.getCrashById = function (database, crashId) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, init, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        argument_contracts_1.default.assertNonWhiteSpaceString(database, 'database');
                        if (crashId <= 0) {
                            throw new Error("Expected id to be a positive non-zero number. Value received: \"".concat(crashId, "\""));
                        }
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('id', crashId.toString());
                        init = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            duplex: 'half'
                        };
                        return [4, this._client.fetch('/api/crash/details', init)];
                    case 1:
                        response = _a.sent();
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (response.status !== 200) {
                            throw new Error(json.message);
                        }
                        return [2, (0, crash_details_1.createCrashDetails)(json)];
                }
            });
        });
    };
    CrashApiClient.prototype.reprocessCrash = function (database_1, crashId_1) {
        return __awaiter(this, arguments, void 0, function (database, crashId, force, processor) {
            if (force === void 0) { force = false; }
            if (processor === void 0) { processor = ''; }
            return __generator(this, function (_a) {
                return [2, this.reprocessCrashes(database, [crashId], force, processor)];
            });
        });
    };
    CrashApiClient.prototype.reprocessCrashes = function (database_1, crashIds_1) {
        return __awaiter(this, arguments, void 0, function (database, crashIds, force, processor) {
            var _i, crashIds_2, crashId, formData, init, response, json;
            if (force === void 0) { force = false; }
            if (processor === void 0) { processor = ''; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        argument_contracts_1.default.assertNonWhiteSpaceString(database, 'database');
                        argument_contracts_1.default.assertBoolean(force, 'force');
                        for (_i = 0, crashIds_2 = crashIds; _i < crashIds_2.length; _i++) {
                            crashId = crashIds_2[_i];
                            if (crashId <= 0) {
                                throw new Error("Expected ids to be positive non-zero numbers. Value received: \"".concat(crashId, "\""));
                            }
                        }
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('id', crashIds.join(','));
                        formData.append('force', force.toString());
                        if (processor) {
                            formData.append('processor', processor);
                        }
                        init = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            duplex: 'half'
                        };
                        return [4, this._client.fetch('/api/crash/reprocess', init)];
                    case 1:
                        response = _a.sent();
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (response.status !== 202) {
                            throw new Error(json.message);
                        }
                        return [2, json];
                }
            });
        });
    };
    CrashApiClient.prototype.postStatus = function (database, groupId, status) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, init, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        argument_contracts_1.default.assertNonWhiteSpaceString(database, 'database');
                        argument_contracts_1.default.assertNumber(groupId, 'groupId');
                        argument_contracts_1.default.assertNumber(status, 'status');
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('groupId', groupId.toString());
                        formData.append('status', status.toString());
                        init = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            duplex: 'half'
                        };
                        return [4, this._client.fetch('/api/crash/status', init)];
                    case 1:
                        response = _a.sent();
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (response.status !== 200) {
                            throw new Error(json.message);
                        }
                        return [2, json];
                }
            });
        });
    };
    return CrashApiClient;
}());
exports.CrashApiClient = CrashApiClient;
//# sourceMappingURL=crash-api-client.js.map