"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrashesApiRow = exports.CrashTypeId = void 0;
var parse_1 = require("../../common/parse");
var CrashTypeId;
(function (CrashTypeId) {
    CrashTypeId[CrashTypeId["unknown"] = 0] = "unknown";
    CrashTypeId[CrashTypeId["windowsNative"] = 1] = "windowsNative";
    CrashTypeId[CrashTypeId["java"] = 4] = "java";
    CrashTypeId[CrashTypeId["crashpad"] = 6] = "crashpad";
    CrashTypeId[CrashTypeId["dotnet"] = 8] = "dotnet";
    CrashTypeId[CrashTypeId["unity"] = 12] = "unity";
    CrashTypeId[CrashTypeId["macOS"] = 13] = "macOS";
    CrashTypeId[CrashTypeId["javascript"] = 14] = "javascript";
    CrashTypeId[CrashTypeId["unityNative"] = 15] = "unityNative";
    CrashTypeId[CrashTypeId["unrealLinuxServer"] = 16] = "unrealLinuxServer";
    CrashTypeId[CrashTypeId["unreal"] = 17] = "unreal";
    CrashTypeId[CrashTypeId["dotnetStandard"] = 18] = "dotnetStandard";
    CrashTypeId[CrashTypeId["angular"] = 19] = "angular";
    CrashTypeId[CrashTypeId["node"] = 20] = "node";
    CrashTypeId[CrashTypeId["xml"] = 21] = "xml";
    CrashTypeId[CrashTypeId["electron"] = 22] = "electron";
    CrashTypeId[CrashTypeId["python"] = 23] = "python";
    CrashTypeId[CrashTypeId["unityDotNetStandard"] = 24] = "unityDotNetStandard";
    CrashTypeId[CrashTypeId["asan"] = 25] = "asan";
    CrashTypeId[CrashTypeId["iOS"] = 26] = "iOS";
    CrashTypeId[CrashTypeId["xbox"] = 27] = "xbox";
    CrashTypeId[CrashTypeId["ps4"] = 28] = "ps4";
    CrashTypeId[CrashTypeId["ps5"] = 29] = "ps5";
    CrashTypeId[CrashTypeId["playStationRecap"] = 30] = "playStationRecap";
})(CrashTypeId || (exports.CrashTypeId = CrashTypeId = {}));
var CrashesApiRow = (function () {
    function CrashesApiRow(rawApiRow) {
        this.id = Number(rawApiRow.id);
        this.groupByCount = Number(rawApiRow.groupByCount) || 0;
        this.status = Number(rawApiRow.status);
        this.stackKey = rawApiRow.stackKey;
        this.stackKeyId = Number(rawApiRow.stackKeyId);
        this.stackId = Number(rawApiRow.stackId);
        this.appName = rawApiRow.appName;
        this.appVersion = rawApiRow.appVersion;
        this.crashTypeId = Number(rawApiRow.crashTypeId) || 0;
        this.appDescription = rawApiRow.appDescription;
        this.userDescription = rawApiRow.userDescription;
        this.user = rawApiRow.user;
        this.email = rawApiRow.email;
        this.ipAddress = rawApiRow.IpAddress;
        this.crashTime = rawApiRow.crashTime;
        this.defectId = rawApiRow.defectId;
        this.defectUrl = rawApiRow.defectUrl;
        this.defectLabel = rawApiRow.defectLabel;
        this.skDefectId = rawApiRow.skDefectId;
        this.skDefectUrl = rawApiRow.skDefectUrl;
        this.skDefectLabel = rawApiRow.skDefectLabel;
        this.comments = rawApiRow.Comments;
        this.skComments = rawApiRow.skComments;
        this.exceptionCode = rawApiRow.exceptionCode;
        this.exceptionMessage = rawApiRow.exceptionMessage;
        this.attributes = (0, parse_1.safeParseJson)(rawApiRow.attributes);
        Object.freeze(this);
    }
    return CrashesApiRow;
}());
exports.CrashesApiRow = CrashesApiRow;
//# sourceMappingURL=crashes-api-row.js.map