export interface EventResponseObject {
    id: string;
    uId: string;
    type: string;
    timestamp: string;
    firstName?: string;
    lastName?: string;
    username: string;
    message: string;
}
export interface Event extends Omit<EventResponseObject, 'type' | 'id' | 'uId'> {
    id: number;
    uId: number;
    type: EventType;
}
export declare enum EventType {
    Comment = "Comment",
    AddCrashDefect = "AddCrashDefect",
    RemoveCrashDefect = "RemoveCrashDefect",
    AddStackKeyDefect = "AddStackKeyDefect",
    RemoveStackKeyDefect = "RemoveStackKeyDefect",
    StackKeyDefectStatusOpen = "StackKeyDefectStatusOpen",
    StackKeyDefectStatusClosed = "StackKeyDefectStatusClosed",
    StackKeyDefectStatusRegression = "StackKeyDefectStatusRegression"
}
export declare function createEvents(events: Array<EventResponseObject>): Array<Event>;
