"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IssueApiClient = void 0;
var argument_contracts_1 = __importDefault(require("argument-contracts"));
var IssueApiClient = (function () {
    function IssueApiClient(_client) {
        this._client = _client;
    }
    IssueApiClient.prototype.postStackKeyIssue = function (database, stackKeyId, notes, linkDefectId) {
        argument_contracts_1.default.assertNonWhiteSpaceString(database, 'database');
        if (stackKeyId <= 0) {
            throw new Error("Expected stackKeyId to be a positive non-zero number. Value received: \"".concat(stackKeyId, "\""));
        }
        var method = 'POST';
        var body = this._client.createFormData();
        var duplex = 'half';
        body.append('database', database);
        body.append('stackKeyId', "".concat(stackKeyId));
        body.append('notes', notes);
        if (linkDefectId) {
            body.append('linkDefectId', linkDefectId);
        }
        return this._client.fetch('/api/logDefect', {
            method: method,
            body: body,
            duplex: duplex,
        });
    };
    IssueApiClient.prototype.deleteStackKeyIssue = function (database, stackKeyId) {
        return this._client.fetch("/api/logDefect?database=".concat(database, "&stackKeyId=").concat(stackKeyId), {
            method: 'DELETE',
        });
    };
    return IssueApiClient;
}());
exports.IssueApiClient = IssueApiClient;
//# sourceMappingURL=issue-api-client.js.map