"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolsApiClient = void 0;
var _common_1 = require("../../common/index");
var delay_1 = require("../../common/delay");
var cancel_1 = require("../../common/cancel");
var SymbolsApiClient = (function () {
    function SymbolsApiClient(_client) {
        this._client = _client;
        this.uploadUrl = '/symsrv/uploadUrl';
        this.uploadCompleteUrl = '/symsrv/uploadComplete';
        this._s3ApiClient = new _common_1.S3ApiClient();
        this._timer = delay_1.delay;
    }
    SymbolsApiClient.prototype.postSymbols = function (database, application, version, files) {
        return __awaiter(this, void 0, void 0, function () {
            var promises;
            var _this = this;
            return __generator(this, function (_a) {
                promises = files
                    .map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                    var originalStream, _a, checkStream, uploadStream, reader, _b, value, done, uploadResponse, presignedUrl, additionalHeaders;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                originalStream = file.file;
                                _a = originalStream.tee(), checkStream = _a[0], uploadStream = _a[1];
                                reader = checkStream.getReader();
                                _c.label = 1;
                            case 1:
                                _c.trys.push([1, , 3, 4]);
                                return [4, reader.read()];
                            case 2:
                                _b = _c.sent(), value = _b.value, done = _b.done;
                                if (done) {
                                    throw new Error('Could not read symbol file stream');
                                }
                                if (!this.isGzipMagicBytes(value)) {
                                    throw new Error('Symbol file stream is not a gzipped stream');
                                }
                                return [3, 4];
                            case 3:
                                reader.releaseLock();
                                (0, cancel_1.safeCancel)(checkStream);
                                return [7];
                            case 4:
                                _c.trys.push([4, , 8, 9]);
                                file.file = uploadStream;
                                return [4, this.getPresignedUrl(database, application, version, file)];
                            case 5:
                                presignedUrl = _c.sent();
                                additionalHeaders = {
                                    'content-encoding': 'gzip'
                                };
                                return [4, this._s3ApiClient.uploadFileToPresignedUrl(presignedUrl, file, additionalHeaders)];
                            case 6:
                                uploadResponse = _c.sent();
                                return [4, this.postUploadComplete(database, application, version, file)];
                            case 7:
                                _c.sent();
                                return [3, 9];
                            case 8:
                                (0, cancel_1.safeCancel)(uploadStream);
                                return [7];
                            case 9: return [4, this._timer(1000)];
                            case 10:
                                _c.sent();
                                return [2, uploadResponse];
                        }
                    });
                }); });
                return [2, Promise.all(promises)];
            });
        });
    };
    SymbolsApiClient.prototype.getPresignedUrl = function (database, appName, appVersion, file) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, request, response, json;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('appName', appName);
                        formData.append('appVersion', appVersion);
                        formData.append('size', "".concat(file.uncompressedSize));
                        formData.append('symFileName', file.name);
                        formData.append('moduleName', file.moduleName);
                        formData.append('dbgId', file.dbgId);
                        formData.append('lastModified', "".concat((_a = file.lastModified) === null || _a === void 0 ? void 0 : _a.toISOString()));
                        formData.append('SendPdbsVersion', 'spdbsv2');
                        request = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            duplex: 'half'
                        };
                        return [4, this._client.fetch(this.uploadUrl, request)];
                    case 1:
                        response = _b.sent();
                        if (response.status === 429) {
                            throw new Error('Error getting presigned URL, too many requests');
                        }
                        if (response.status === 403) {
                            throw new Error('Error getting presigned URL, invalid credentials');
                        }
                        if (response.status !== 200) {
                            throw new Error("Error getting presigned URL for ".concat(file.name));
                        }
                        return [4, response.json()];
                    case 2:
                        json = _b.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, json.url];
                }
            });
        });
    };
    SymbolsApiClient.prototype.postUploadComplete = function (database, appName, appVersion, file) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, request, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('appName', appName);
                        formData.append('appVersion', appVersion);
                        formData.append('size', "".concat(file.uncompressedSize));
                        formData.append('symFileName', file.name);
                        formData.append('moduleName', file.moduleName);
                        formData.append('dbgId', file.dbgId);
                        formData.append('lastModified', "".concat(file.lastModified));
                        formData.append('SendPdbsVersion', 'spdbsv2');
                        request = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            duplex: 'half'
                        };
                        return [4, this._client.fetch(this.uploadCompleteUrl, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error completing symbol upload for ".concat(file.name, ", status ").concat(response.status));
                        }
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, response];
                }
            });
        });
    };
    SymbolsApiClient.prototype.isGzipMagicBytes = function (buffer) {
        var view = new Uint8Array(buffer);
        return view[0] === 0x1f && view[1] === 0x8b;
    };
    return SymbolsApiClient;
}());
exports.SymbolsApiClient = SymbolsApiClient;
//# sourceMappingURL=symbols-api-client.js.map