import { ApiClient, BugSplatResponse, TableDataResponse } from '../../common/index';
import { UsersTableDataRequest } from './users-table-data-request';
import { UsersApiRow } from './users-api-row';
export declare class UsersApiClient {
    private _client;
    constructor(_client: ApiClient);
    getUsers(request: UsersTableDataRequest): Promise<TableDataResponse<UsersApiRow>>;
    addUserToDatabase(database: string, email: string): Promise<BugSplatResponse<AddUserResponse>>;
    removeUserFromDatabase(database: string, email: string): Promise<BugSplatResponse<UsersApiResponse>>;
    updateUserForDatabase(database: string, email: string, isRestricted: boolean): Promise<BugSplatResponse<AddUserResponse>>;
    addUserToCompany(companyId: number, email: string): Promise<BugSplatResponse<AddUserResponse>>;
    removeUserFromCompany(companyId: number, uId: number): Promise<BugSplatResponse<UsersApiResponse>>;
}
export declare enum UserApiResponseStatus {
    success = "success",
    warning = "warning",
    fail = "fail"
}
export interface UsersApiResponse {
    status: UserApiResponseStatus;
    message?: string;
}
export interface AddUserResponse extends UsersApiResponse {
    database?: string;
    companyId?: number;
    uId: number;
}
