"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserApiResponseStatus = exports.UsersApiClient = void 0;
var USERS_BASE_URL = '/api/user/users.php';
var UsersApiClient = (function () {
    function UsersApiClient(_client) {
        this._client = _client;
    }
    UsersApiClient.prototype.getUsers = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var database, companyId, email, params, url, response, rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        database = request.database, companyId = request.companyId, email = request.email;
                        if (database && companyId) {
                            throw new Error('Cannot specify both database and companyId');
                        }
                        if (!database && !companyId) {
                            throw new Error('Must specify either database or companyId');
                        }
                        params = new URLSearchParams();
                        if (database) {
                            params.append('database', database);
                        }
                        if (companyId) {
                            params.append('companyId', companyId.toString());
                        }
                        if (email) {
                            params.append('username', email);
                        }
                        url = "".concat(USERS_BASE_URL, "?").concat(params.toString());
                        return [4, this._client.fetch(url)];
                    case 1:
                        response = _a.sent();
                        return [4, response.json()];
                    case 2:
                        rows = _a.sent();
                        return [2, {
                                rows: rows,
                            }];
                }
            });
        });
    };
    UsersApiClient.prototype.addUserToDatabase = function (database, email) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, request, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('username', email);
                        request = {
                            method: 'POST',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            body: formData,
                        };
                        return [4, this._client.fetch(USERS_BASE_URL, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error adding user ".concat(email, " to database ").concat(database, " status ").concat(response.status));
                        }
                        return [2, response];
                }
            });
        });
    };
    UsersApiClient.prototype.removeUserFromDatabase = function (database, email) {
        return __awaiter(this, void 0, void 0, function () {
            var url, request, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "".concat(USERS_BASE_URL, "?database=").concat(database, "&username=").concat(encodeURIComponent(email));
                        request = {
                            method: 'DELETE',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                        };
                        return [4, this._client.fetch(url, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error remove user ".concat(email, " for ").concat(database, " status ").concat(response.status));
                        }
                        return [2, response];
                }
            });
        });
    };
    UsersApiClient.prototype.updateUserForDatabase = function (database, email, isRestricted) {
        return __awaiter(this, void 0, void 0, function () {
            var rights, formData, request, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rights = isRestricted ? '0' : '1';
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('username', email);
                        formData.append('rights', rights);
                        request = {
                            method: 'POST',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            body: formData,
                        };
                        return [4, this._client.fetch(USERS_BASE_URL, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error updating user ".concat(email, " in database ").concat(database, " status ").concat(response.status));
                        }
                        return [2, response];
                }
            });
        });
    };
    UsersApiClient.prototype.addUserToCompany = function (companyId, email) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, request, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = this._client.createFormData();
                        formData.append('companyId', companyId.toString());
                        formData.append('username', email);
                        request = {
                            method: 'POST',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            body: formData,
                        };
                        return [4, this._client.fetch(USERS_BASE_URL, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error adding user ".concat(email, " to company ").concat(companyId, " status ").concat(response.status));
                        }
                        return [2, response];
                }
            });
        });
    };
    UsersApiClient.prototype.removeUserFromCompany = function (companyId, uId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, request, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "".concat(USERS_BASE_URL, "?companyId=").concat(companyId, "&uId=").concat(uId);
                        request = {
                            method: 'DELETE',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                        };
                        return [4, this._client.fetch(url, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error removing user ".concat(uId, " for company ").concat(companyId, " status ").concat(response.status));
                        }
                        return [2, response];
                }
            });
        });
    };
    return UsersApiClient;
}());
exports.UsersApiClient = UsersApiClient;
var UserApiResponseStatus;
(function (UserApiResponseStatus) {
    UserApiResponseStatus["success"] = "success";
    UserApiResponseStatus["warning"] = "warning";
    UserApiResponseStatus["fail"] = "fail";
})(UserApiResponseStatus || (exports.UserApiResponseStatus = UserApiResponseStatus = {}));
//# sourceMappingURL=users-api-client.js.map