"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VersionsApiClient = void 0;
var _common_1 = require("../../common/index");
var delay_1 = require("../../common/delay");
var versions_api_row_1 = require("../versions-api-row/versions-api-row");
var VersionsApiClient = (function () {
    function VersionsApiClient(_client) {
        this._client = _client;
        this.route = '/api/versions';
        this._s3ApiClient = new _common_1.S3ApiClient();
        this._timer = delay_1.delay;
        this._tableDataClient = new _common_1.TableDataClient(this._client, this.route);
    }
    VersionsApiClient.prototype.getVersions = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var response, json, pageData, rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._tableDataClient.getData(request)];
                    case 1:
                        response = _a.sent();
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        pageData = json.pageData;
                        rows = json.rows.map(function (row) { return new versions_api_row_1.VersionsApiRow(row); });
                        return [2, {
                                rows: rows,
                                pageData: pageData
                            }];
                }
            });
        });
    };
    VersionsApiClient.prototype.deleteVersions = function (database, appVersions) {
        return __awaiter(this, void 0, void 0, function () {
            var appVersionsParam, route, request, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        appVersionsParam = appVersions.reduce(function (prev, curr) { return __spreadArray(__spreadArray([], prev, true), [curr.application, curr.version], false); }, []).join(',');
                        route = "".concat(this.route, "?database=").concat(database, "&appVersions=").concat(appVersionsParam);
                        request = {
                            method: 'DELETE',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow'
                        };
                        return [4, this._client.fetch(route, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error deleting symbols for ".concat(database, "-").concat(appVersionsParam, " status ").concat(response.status));
                        }
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, response];
                }
            });
        });
    };
    VersionsApiClient.prototype.putFullDumps = function (database, application, version, fullDumps) {
        return __awaiter(this, void 0, void 0, function () {
            var fullDumpsFlag, route, request;
            return __generator(this, function (_a) {
                fullDumpsFlag = fullDumps ? '1' : '0';
                route = "".concat(this.route, "?database=").concat(database, "&appName=").concat(application, "&appVersion=").concat(version, "&fullDumps=").concat(fullDumpsFlag);
                request = {
                    method: 'PUT',
                    cache: 'no-cache',
                    credentials: 'include',
                    redirect: 'follow'
                };
                return [2, this._client.fetch(route, request)];
            });
        });
    };
    VersionsApiClient.prototype.putRetired = function (database, application, version, retired) {
        return __awaiter(this, void 0, void 0, function () {
            var retiredFlag, route, request;
            return __generator(this, function (_a) {
                retiredFlag = retired ? '1' : '0';
                route = "".concat(this.route, "?database=").concat(database, "&appName=").concat(application, "&appVersion=").concat(version, "&retired=").concat(retiredFlag);
                request = {
                    method: 'PUT',
                    cache: 'no-cache',
                    credentials: 'include',
                    redirect: 'follow'
                };
                return [2, this._client.fetch(route, request)];
            });
        });
    };
    VersionsApiClient.prototype.deleteSymbols = function (database, application, version) {
        return __awaiter(this, void 0, void 0, function () {
            var route, request, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        route = "".concat(this.route, "?database=").concat(database, "&appName=").concat(application, "&appVersion=").concat(version);
                        request = {
                            method: 'DELETE',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow'
                        };
                        return [4, this._client.fetch(route, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error deleting symbols for ".concat(database, "-").concat(application, "-").concat(version, " status ").concat(response.status));
                        }
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, response];
                }
            });
        });
    };
    VersionsApiClient.prototype.postSymbols = function (database, application, version, files) {
        return __awaiter(this, void 0, void 0, function () {
            var promises;
            var _this = this;
            return __generator(this, function (_a) {
                promises = files
                    .map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                    var presignedUrl, response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, this.getPresignedUrl(database, application, version, file)];
                            case 1:
                                presignedUrl = _a.sent();
                                return [4, this._s3ApiClient.uploadFileToPresignedUrl(presignedUrl, file)];
                            case 2:
                                response = _a.sent();
                                return [4, this._timer(1000)];
                            case 3:
                                _a.sent();
                                return [2, response];
                        }
                    });
                }); });
                return [2, Promise.all(promises)];
            });
        });
    };
    VersionsApiClient.prototype.getPresignedUrl = function (database, appName, appVersion, file) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, request, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = this._client.createFormData();
                        formData.append('database', database);
                        formData.append('appName', appName);
                        formData.append('appVersion', appVersion);
                        formData.append('size', "".concat(file.size));
                        formData.append('symFileName', file.name);
                        if (file.dbgId) {
                            formData.append('dbgId', file.dbgId);
                        }
                        if (file.lastModified) {
                            formData.append('lastModified', "".concat(file.lastModified));
                        }
                        if (file.moduleName) {
                            formData.append('moduleName', file.moduleName);
                        }
                        request = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow',
                            duplex: 'half'
                        };
                        return [4, this._client.fetch(this.route, request)];
                    case 1:
                        response = _a.sent();
                        if (response.status === 429) {
                            throw new Error('Error getting presigned URL, too many requests');
                        }
                        if (response.status === 403) {
                            throw new Error('Error getting presigned URL, invalid credentials');
                        }
                        if (response.status !== 200) {
                            throw new Error("Error getting presigned URL for ".concat(file.name));
                        }
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, json.url];
                }
            });
        });
    };
    return VersionsApiClient;
}());
exports.VersionsApiClient = VersionsApiClient;
//# sourceMappingURL=versions-api-client.js.map