import { ApiClient, BugSplatResponse, Environment } from '../../index';
import { BugSplatLoginResponse } from './bugsplat-login-response';
export declare class BugSplatApiClient implements ApiClient {
    private _host;
    private _environment;
    private _createFormData;
    private _fetch;
    private _headers;
    constructor(_host?: string, _environment?: Environment);
    static createAuthenticatedClientForNode(email: string, password: string, host?: string): Promise<BugSplatApiClient>;
    static createAuthenticatedClientForWebBrowser(email: string, password: string, host?: string): Promise<BugSplatApiClient>;
    createFormData(): FormData;
    fetch<T>(route: string, init?: RequestInit): Promise<BugSplatResponse<T>>;
    login(email: string, password: string): Promise<BugSplatResponse<BugSplatLoginResponse>>;
    private parseCookies;
    private parseXsrfToken;
}
