import { QueryFilter, FilterOperator } from '../../../index';
export class QueryFilterGroup {
    filters;
    filterOperator;
    groupOperator;
    constructor(filters, filterOperator = FilterOperator.and, groupOperator = FilterOperator.and) {
        this.filters = filters;
        this.filterOperator = filterOperator;
        this.groupOperator = groupOperator;
        Object.freeze(this);
    }
    static fromApiTableFilter(filter) {
        return new QueryFilterGroup([filter]);
    }
    static fromColumnValues(values, columnName, filterOperator = FilterOperator.or) {
        return new QueryFilterGroup(values.map(value => new QueryFilter(value, 'EQUAL', columnName)), filterOperator);
    }
    static fromTimeFrame(columnName, startDate, endDate) {
        const filters = [];
        if (startDate) {
            filters.push(new QueryFilter(startDate.toISOString(), 'GREATER_THAN', columnName));
        }
        if (endDate) {
            filters.push(new QueryFilter(endDate.toISOString(), 'LESS_THAN', columnName));
        }
        return new QueryFilterGroup(filters);
    }
}
//# sourceMappingURL=query-filter-group.js.map