import { AdditionalInfo, GroupableThreadCollection } from '../index';
import { Event } from '../../events/index';
import { EventResponseObject } from '../../events/events-api-client/event';
import { AdditionalInfoResponseObject } from '../additional-info/additional-info';
export declare enum ProcessingStatus {
    Processing = 0,
    ActiveThreadComplete = 1,
    Complete = 2
}
export declare enum DefectTrackerType {
    None = "None",
    FogBugz = "FogBugz",
    Jira = "Jira",
    Azure = "Azure DevOps",
    YouTrack = "YouTrack",
    GitHub = "GitHub",
    Assembla = "Assembla",
    Monday = "Monday",
    GitLab = "GitLab",
    Favro = "Favro"
}
export declare enum CrashStatus {
    Open = 0,
    Closed = 1,
    Regression = 2
}
export interface CrashDetails {
    processed: ProcessingStatus;
    appKey: string;
    appName: string;
    appVersion: string;
    attributes: Record<string, unknown>;
    comments: string;
    crashTime: string;
    defectTrackerType: DefectTrackerType;
    defectId: string;
    defectLabel: string;
    defectUrl: string;
    description: string;
    dumpfile: string;
    dumpfileSize: number;
    email: string;
    events: Array<Event>;
    exceptionCode: string;
    exceptionMessage: string;
    id: number;
    ipAddress: string;
    missingSymbols: boolean;
    nextCrashId: number;
    platform: string;
    previousCrashId: number;
    processor: string;
    status: CrashStatus;
    stackKey: string;
    stackKeyComment: string;
    stackKeyId: number;
    stackKeyDefectId: number;
    stackKeyDefectLabel: string;
    stackKeyDefectUrl: string;
    thread: GroupableThreadCollection;
    user: string;
    additionalInfo: AdditionalInfo;
}
export declare function createCrashDetails(options: CrashDetailsRawResponse): CrashDetails;
export interface CrashDetailsRawResponse extends Partial<Omit<CrashDetails, 'events' | 'debuggerOutput' | 'attributes'>> {
    attributes?: string;
    events?: Array<EventResponseObject>;
    debuggerOutput?: AdditionalInfoResponseObject;
}
