import ac from 'argument-contracts';
export class IssueApiClient {
    _client;
    constructor(_client) {
        this._client = _client;
    }
    postStackKeyIssue(database, stackKeyId, notes, linkDefectId) {
        ac.assertNonWhiteSpaceString(database, 'database');
        if (stackKeyId <= 0) {
            throw new Error(`Expected stackKeyId to be a positive non-zero number. Value received: "${stackKeyId}"`);
        }
        const method = 'POST';
        const body = this._client.createFormData();
        const duplex = 'half';
        body.append('database', database);
        body.append('stackKeyId', `${stackKeyId}`);
        body.append('notes', notes);
        if (linkDefectId) {
            body.append('linkDefectId', linkDefectId);
        }
        return this._client.fetch('/api/logDefect', {
            method,
            body,
            duplex,
        });
    }
    deleteStackKeyIssue(database, stackKeyId) {
        return this._client.fetch(`/api/logDefect?database=${database}&stackKeyId=${stackKeyId}`, {
            method: 'DELETE',
        });
    }
}
//# sourceMappingURL=issue-api-client.js.map