import { TableDataClient } from '../../common/index';
import { SummaryApiRow } from '../summary-api-row/summary-api-row';
export class SummaryApiClient {
    _client;
    _tableDataClient;
    constructor(_client) {
        this._client = _client;
        this._tableDataClient = new TableDataClient(this._client, '/summary?data');
    }
    async getSummary(request) {
        const formParts = {};
        if (request.applications && request.applications.length) {
            formParts['appNames'] = request.applications.join(',');
        }
        if (request.versions && request.versions.length) {
            formParts['versions'] = request.versions.join(',');
        }
        const response = await this._tableDataClient.postGetData(request, formParts);
        const json = await response.json();
        const pageData = json.pageData;
        const rows = json.rows.map(row => new SummaryApiRow(row.stackKey, Number(row.stackKeyId), row.firstReport, row.lastReport, row.crashSum, row.techSupportSubject, row.stackKeyDefectId, row.stackKeyDefectUrl, row.stackKeyDefectLabel, row.comments, Number(row.subKeyDepth), Number(row.userSum), Number(row.status)));
        return {
            rows,
            pageData
        };
    }
}
//# sourceMappingURL=summary-api-client.js.map