import { ApiClient, BugSplatResponse, SymbolFile, TableDataRequest, TableDataResponse } from '../../common/index';
import { VersionsApiRow } from '../versions-api-row/versions-api-row';
import { PutRetiredResponse } from './put-retired-response';
export declare class VersionsApiClient {
    private _client;
    private readonly route;
    private _s3ApiClient;
    private _tableDataClient;
    private _timer;
    constructor(_client: ApiClient);
    getVersions(request: TableDataRequest): Promise<TableDataResponse<VersionsApiRow>>;
    deleteVersions(database: string, appVersions: Array<{
        application: string;
        version: string;
    }>): Promise<BugSplatResponse>;
    putFullDumps(database: string, application: string, version: string, fullDumps: boolean): Promise<BugSplatResponse>;
    putRetired(database: string, application: string, version: string, retired: boolean): Promise<BugSplatResponse<PutRetiredResponse>>;
    deleteSymbols(database: string, application: string, version: string): Promise<BugSplatResponse>;
    postSymbols(database: string, application: string, version: string, files: Array<SymbolFile>): Promise<Array<BugSplatResponse>>;
    private getPresignedUrl;
}
